package chap10.program05

import chap10.program03._

object SimpleParserTest2 {
  def main(args: Array[String]) : Unit = {
    test("Test1: ", "1 + 2")
    test("Test2: ", "1 - 2")
    test("Test3: ", "8")
  }

  def test(caption: String, data: String) {
    print(caption + data)
    try {
      val ir = new SimpleParser2(new SimpleLexer(data)).expression
      println(" ==> " + calc(ir))
    } catch {
      case e:Exception => println("failed: " + e)
    }
  }

  def calc(ir:IR) = ir.operator match {
    case Operator("+") => ir.operand1 + ir.operand2
    case Operator("-") => ir.operand1 - ir.operand2
    case _ => ir.operand1
  }
}
