package chap10.program08

import chap10.program07._
import scala.util.parsing.combinator._

class CombinatorParser3 extends JavaTokenParsers {
  def parse(data: String) = parseAll(expression, data)

  // <式> ::= <項> {"+" <項> | "-" <項>}
  def expression: Parser[IR2] = term~rep("+"~term | "-"~term) ^^ {
    case opr1~lists => {
      var operand1 = opr1

      lists.foreach {l => l match {
          case "+"~f => {operand1 = Operator("+", operand1, f)}
          case "-"~f => {operand1 = Operator("-", operand1, f)}
      }}
      operand1
    }
  }

  // <項> ::= <因子> {"*" <因子> | "/" <因子>}
  def term: Parser[IR2] = factor~rep("*"~factor | "/"~factor) ^^ {
    case opr1~lists => {
      var operand1 = opr1

      lists.foreach {l => l match {
        case "*"~f => {operand1 = Operator("*", operand1, f)}
        case "/"~f => {operand1 = Operator("/", operand1, f)}
      }}
      operand1
    }
  }

  // <因子> ::= [0-9]+ | "(" <式> ")"
  def factor: Parser[IR2] =
    """\d+""".r ^^ { n => Number(n.toFloat)} |
    "("~expression~")" ^^ { case lbrace~expr~rbrace => expr}
}
